unit iotester;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, winbinfile;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    FileNameEdit: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    OffsetEdit: TEdit;
    LengthEdit: TEdit;
    Button2: TButton;
    DebugMemo: TMemo;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BinFile : TBinaryFile;

    procedure Debug(S : String);
    procedure BinDebug(S : String);

  end;

var
  Form1: TForm1;

implementation

uses md5;

{$R *.DFM}

procedure TForm1.Debug(S : String);
begin
   DebugMemo.Lines.Add(S);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   BinFile := TBinaryFile.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   Error : DWORD;
begin
   BinFile.Assign(FileNameEdit.Text);
   if not BinFile.Open(OPEN_READ_ONLY) then
   begin
      Error := GetLastError;
      MessageDlg(SysErrorMessage(Error), mtError, [mbOK], 0);
   end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   Offset : Int64;
   Length : Int64;
   Actual : Int64;
   Buffer : String;
begin
   Offset := StrToInt64(OffsetEdit.Text);
   Length := StrToInt64(LengthEdit.Text);

   BinFile.Seek(Offset);
   SetLength(Buffer, Length);
   Actual := BinFile.BlockRead2(PChar(Buffer), Length);

   Debug('Read ' + IntToStr(Actual) + ' bytes');
   SetLength(Buffer, Actual);

   BinDebug(Buffer);

end;

procedure TForm1.BinDebug(S : String);
var
   i : Integer;
   j : Integer;
   d : String;
begin
   j := 0;
   d := '';
   for i := 1 to Length(S) do
   begin
      d := d + IntToHex(Ord(S[i]), 2) + ' ';
      Inc(j);
      if j = 16 then
      begin
         Debug(d);
         d := '';
         j := 0;
      end;
   end;
   Debug(d);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   Debug(MD5Hash(FileNameEdit.Text));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
   begin
      FileNameEdit.Text := OpenDialog1.FileName;
   end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   i : Integer;
   Offset : Int64;
   Buffer : String;
   n : Integer;
begin
   for i := 0 to 4097 do
   begin
      Offset := Int64(i) * 1024 * 1024;
      BinFile.Seek(Offset);
      SetLength(Buffer, 8);
      BinFile.BlockRead2(PChar(Buffer), Length(Buffer));
      BinDebug(Buffer);
      n := PInteger(@(PChar(Buffer)[4]))^;
      if n <> i then
      begin
         Debug(IntToStr(n));
         break;
      end;
   end;
end;

end.
