/*
	$Header: /home/itig/cvsroot/ext2ifs/src/mem.c,v 1.5 2000/10/12 13:09:16 jn Exp $
*/

#include "ext2fs.h"

PVOID
XtMMAllocatePool (
    IN POOL_TYPE    PoolType,
    IN ULONG        NumberOfBytes
    )
{
    PVOID P;

#if DBG

	PoolType = NonPagedPoolCacheAligned;

//	KdPrint(("[EXT2]: XtMMAllocatePool len = %d\n", NumberOfBytes));

    NumberOfBytes += sizeof(FSD_ALLOC_HEADER);

#endif // DBG

    P = ExAllocatePool(PoolType, NumberOfBytes);

#if DBG

    if (P)
    {
//        RtlFillMemory(P, NumberOfBytes, 'A');
		RtlZeroMemory(P, NumberOfBytes);

        ((PFSD_ALLOC_HEADER)P)->Identifier.Type = 'AAAA';
        ((PFSD_ALLOC_HEADER)P)->Identifier.Size = NumberOfBytes;

        return (PVOID)((PUCHAR)P + sizeof(FSD_ALLOC_HEADER));
    }
    else
    {
        KdPrint((DRIVER_NAME ": FsdAllocatePool: ExAllocatePool failed\n"));

        return NULL;
    }

#else // !DBG

    return P;

#endif // !DBG

}

PVOID
XtMMAllocatePoolStruct (
    IN POOL_TYPE    PoolType,
    IN ULONG        NumberOfBytes,
	IN FSD_IDENTIFIER_TYPE StructType
    )
{
	PVOID result = XtMMAllocatePool(PoolType, NumberOfBytes);
	if(result)
	{
        ((PFSD_ALLOC_HEADER)result)->Identifier.Type = StructType;
        ((PFSD_ALLOC_HEADER)result)->Identifier.Size = NumberOfBytes;
	}

	return result;
}


VOID
XtMMFreePool (
    IN PVOID P,
    IN ULONG NumberOfBytes
    )
{
    ASSERT(P != NULL);

#if DBG

    NumberOfBytes += sizeof(FSD_ALLOC_HEADER);

    P = (PVOID)((PUCHAR)P - sizeof(FSD_ALLOC_HEADER));

    ASSERT(((PFSD_ALLOC_HEADER)P)->Identifier.Type == 'AAAA');
    ASSERT(((PFSD_ALLOC_HEADER)P)->Identifier.Size == NumberOfBytes);

    RtlFillMemory(P, NumberOfBytes, 'F');

#endif // !DBG

    ExFreePool(P);
}
